---
title: Bounce off the walls
slug: Games/Tutorials/2D_breakout_game_Phaser/Bounce_off_the_walls
tags:
  - 2D
  - Beginner
  - Canvas
  - Games
  - JavaScript
  - Phaser
  - Tutorial
  - bouncing
---
<div>{{GamesSidebar}}</div>

<p>{{PreviousNext("Games/Workflows/2D_Breakout_game_Phaser/Physics", "Games/Workflows/2D_Breakout_game_Phaser/Player_paddle_and_controls")}}</p>

<div class="summary">
<p>This is the <strong>6th step</strong> out of 16 of the <a href="/en-US/docs/Games/Workflows/2D_Breakout_game_Phaser">Gamedev Phaser tutorial</a>. You can find the source code as it should look after completing this lesson at <a href="https://github.com/end3r/Gamedev-Phaser-Content-Kit/blob/gh-pages/demos/lesson06.html">Gamedev-Phaser-Content-Kit/demos/lesson06.html</a>.</p>
</div>

<p><span class="seoSummary">Now that physics have been introduced, we can start implementing collision detection into the game — first we'll look at the walls.</span></p>

<h2 id="Bouncing_off_the_world_boundaries">Bouncing off the world boundaries</h2>

<p>The easiest way to get our ball bouncing off the walls is to tell the framework that we want to treat the boundaries of the {{htmlelement("canvas")}} element as walls and not let the ball move past them. In Phaser this can be easily accomplished using the <code>collideWorldsBound</code> property. Add this line right after the existing <code>game.physics.enable()</code> method call:</p>

<pre class="brush: js notranslate">ball.body.collideWorldBounds = true;
</pre>

<p>Now the ball will stop at the edge of the screen instead of disappearing, but it doesn't bounce. To make this occur we have to set its bounciness. Add the following line below the previous one:</p>

<pre class="brush: js notranslate">ball.body.bounce.set(1);
</pre>

<p>Try reloading index.html again — now you should see the ball bouncing off all the walls and moving inside the canvas area.</p>

<h2 id="Compare_your_code">Compare your code</h2>

<p>You can check the finished code for this lesson in the live demo below, and play with it to understand better how it works:</p>

<p>{{JSFiddleEmbed("https://jsfiddle.net/end3r/dcw36opz/","","400")}}</p>

<h2 id="Next_steps">Next steps</h2>

<p>This is starting to look more like a game now, but we can't control it in any way — it's high time we introduced the <a href="/en-US/docs/Games/Workflows/2D_Breakout_game_Phaser/Player_paddle_and_controls">player paddle and controls</a>.</p>

<p>{{PreviousNext("Games/Workflows/2D_Breakout_game_Phaser/Physics", "Games/Workflows/2D_Breakout_game_Phaser/Player_paddle_and_controls")}}</p>
